"use strict";
/**
 * Fork from https://github.com/olov/ast-traverse.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.traverse = void 0;
var utils_1 = require("./utils");
function traverse(root, options) {
    if (options === void 0) { options = {}; }
    var pre = options.pre, post = options.post, skipProperty = options.skipProperty;
    var visit = function (node, parent) {
        var res;
        if (!node) {
            return;
        }
        if (pre) {
            res = pre(node, parent);
        }
        if ((0, utils_1.isElementNode)(node) || (0, utils_1.isRootNode)(node)) {
            var children = node.children;
            if (res !== false && Array.isArray(children) && children.length >= 0) {
                children.forEach(function (child) {
                    if (skipProperty && skipProperty(node)) {
                        return;
                    }
                    if ((0, utils_1.isElementNode)(child)) {
                        visit(child, node);
                    }
                });
            }
            if (post) {
                post(node, parent);
            }
        }
    };
    visit(root, null);
}
exports.traverse = traverse;
